# coding: utf-8

"""
    ChannelEngine Merchant API

    ChannelEngine API for merchants  # noqa: E501

    The version of the OpenAPI document: 2.9.3
    Generated by: https://openapi-generator.tech
"""


from __future__ import absolute_import

import re  # noqa: F401

# python 2 and python 3 compatibility library
import six

from channelengine_merchant_api_client.api_client import ApiClient
from channelengine_merchant_api_client.exceptions import (  # noqa: F401
    ApiTypeError,
    ApiValueError
)


class NotificationApi(object):
    """NOTE: This class is auto generated by OpenAPI Generator
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client

    def notification_index(self, **kwargs):  # noqa: E501
        """Get Notifications.  # noqa: E501

        Gets all notifications based on filter.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.notification_index(async_req=True)
        >>> result = thread.get()

        :param from_date: Filter on the notification date, starting from this date. This date is inclusive.
        :type from_date: datetime
        :param to_date: Filter on the notification date, until this date. This date is exclusive.
        :type to_date: datetime
        :param types: Notification type(s) to filter on.
        :type types: list[NotificationType]
        :param merchant_order_nos: Filter on unique order reference used by the merchant.
        :type merchant_order_nos: list[str]
        :param channel_order_nos: Filter on unique order reference used by the channel.
        :type channel_order_nos: list[str]
        :param merchant_return_nos: Filter on unique return reference used by the merchant.
        :type merchant_return_nos: list[str]
        :param channel_return_nos: Filter on unique return reference used by the channel.
        :type channel_return_nos: list[str]
        :param merchant_shipment_nos: Filter on unique shipment reference used by the merchant.
        :type merchant_shipment_nos: list[str]
        :param page: The page to filter on. Starts at 1.
        :type page: int
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _preload_content: if False, the urllib3.HTTPResponse object will
                                 be returned without reading/decoding response
                                 data. Default is True.
        :type _preload_content: bool, optional
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: CollectionOfMerchantNotificationResponse
        """
        kwargs['_return_http_data_only'] = True
        return self.notification_index_with_http_info(**kwargs)  # noqa: E501

    def notification_index_with_http_info(self, **kwargs):  # noqa: E501
        """Get Notifications.  # noqa: E501

        Gets all notifications based on filter.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.notification_index_with_http_info(async_req=True)
        >>> result = thread.get()

        :param from_date: Filter on the notification date, starting from this date. This date is inclusive.
        :type from_date: datetime
        :param to_date: Filter on the notification date, until this date. This date is exclusive.
        :type to_date: datetime
        :param types: Notification type(s) to filter on.
        :type types: list[NotificationType]
        :param merchant_order_nos: Filter on unique order reference used by the merchant.
        :type merchant_order_nos: list[str]
        :param channel_order_nos: Filter on unique order reference used by the channel.
        :type channel_order_nos: list[str]
        :param merchant_return_nos: Filter on unique return reference used by the merchant.
        :type merchant_return_nos: list[str]
        :param channel_return_nos: Filter on unique return reference used by the channel.
        :type channel_return_nos: list[str]
        :param merchant_shipment_nos: Filter on unique shipment reference used by the merchant.
        :type merchant_shipment_nos: list[str]
        :param page: The page to filter on. Starts at 1.
        :type page: int
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _return_http_data_only: response data without head status code
                                       and headers
        :type _return_http_data_only: bool, optional
        :param _preload_content: if False, the urllib3.HTTPResponse object will
                                 be returned without reading/decoding response
                                 data. Default is True.
        :type _preload_content: bool, optional
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the authentication
                              in the spec for a single request.
        :type _request_auth: dict, optional
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: tuple(CollectionOfMerchantNotificationResponse, status_code(int), headers(HTTPHeaderDict))
        """

        local_var_params = locals()

        all_params = [
            'from_date',
            'to_date',
            'types',
            'merchant_order_nos',
            'channel_order_nos',
            'merchant_return_nos',
            'channel_return_nos',
            'merchant_shipment_nos',
            'page'
        ]
        all_params.extend(
            [
                'async_req',
                '_return_http_data_only',
                '_preload_content',
                '_request_timeout',
                '_request_auth'
            ]
        )

        for key, val in six.iteritems(local_var_params['kwargs']):
            if key not in all_params:
                raise ApiTypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method notification_index" % key
                )
            local_var_params[key] = val
        del local_var_params['kwargs']

        collection_formats = {}

        path_params = {}

        query_params = []
        if 'from_date' in local_var_params and local_var_params['from_date'] is not None:  # noqa: E501
            query_params.append(('fromDate', local_var_params['from_date']))  # noqa: E501
        if 'to_date' in local_var_params and local_var_params['to_date'] is not None:  # noqa: E501
            query_params.append(('toDate', local_var_params['to_date']))  # noqa: E501
        if 'types' in local_var_params and local_var_params['types'] is not None:  # noqa: E501
            query_params.append(('types', local_var_params['types']))  # noqa: E501
            collection_formats['types'] = 'multi'  # noqa: E501
        if 'merchant_order_nos' in local_var_params and local_var_params['merchant_order_nos'] is not None:  # noqa: E501
            query_params.append(('merchantOrderNos', local_var_params['merchant_order_nos']))  # noqa: E501
            collection_formats['merchantOrderNos'] = 'multi'  # noqa: E501
        if 'channel_order_nos' in local_var_params and local_var_params['channel_order_nos'] is not None:  # noqa: E501
            query_params.append(('channelOrderNos', local_var_params['channel_order_nos']))  # noqa: E501
            collection_formats['channelOrderNos'] = 'multi'  # noqa: E501
        if 'merchant_return_nos' in local_var_params and local_var_params['merchant_return_nos'] is not None:  # noqa: E501
            query_params.append(('merchantReturnNos', local_var_params['merchant_return_nos']))  # noqa: E501
            collection_formats['merchantReturnNos'] = 'multi'  # noqa: E501
        if 'channel_return_nos' in local_var_params and local_var_params['channel_return_nos'] is not None:  # noqa: E501
            query_params.append(('channelReturnNos', local_var_params['channel_return_nos']))  # noqa: E501
            collection_formats['channelReturnNos'] = 'multi'  # noqa: E501
        if 'merchant_shipment_nos' in local_var_params and local_var_params['merchant_shipment_nos'] is not None:  # noqa: E501
            query_params.append(('merchantShipmentNos', local_var_params['merchant_shipment_nos']))  # noqa: E501
            collection_formats['merchantShipmentNos'] = 'multi'  # noqa: E501
        if 'page' in local_var_params and local_var_params['page'] is not None:  # noqa: E501
            query_params.append(('page', local_var_params['page']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['apiKey']  # noqa: E501

        return self.api_client.call_api(
            '/v2/notifications', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='CollectionOfMerchantNotificationResponse',  # noqa: E501
            auth_settings=auth_settings,
            async_req=local_var_params.get('async_req'),
            _return_http_data_only=local_var_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=local_var_params.get('_preload_content', True),
            _request_timeout=local_var_params.get('_request_timeout'),
            collection_formats=collection_formats,
            _request_auth=local_var_params.get('_request_auth'))
